#ifndef _BFM_QDP_G5DPARAMS_H_
#define _BFM_QDP_G5DPARAMS_H_

// Ugly descriptor for the action
class g5dParams {
 public:

  void VranasMobiusScale(void) {
    mobius_scale = 1+Ls*(1.0/8.0); // Formula from Brower & Vranas  
  }
 void ScaledShamirCayleyTanh(double _mass, double _M5, int _Ls,double _mobius_scale){
    mass=_mass; M5=_M5; Ls=_Ls;
    zolo_hi=0.0;
    zolo_lo=0.0;
    mobius_scale = _mobius_scale;
    solver = HmCayleyTanh;
  }
  void ShamirCayleyTanh(double _mass, double _M5, int _Ls){
    mass=_mass; M5=_M5; Ls=_Ls;
    zolo_hi=0.0;
    zolo_lo=0.0;
    mobius_scale = 1.0;
    solver = HtCayleyTanh;
  }
  void ShamirCayleyZolo(double _mass, double _M5, int _Ls,double _zolo_lo,double _zolo_hi){
    mass=_mass; M5=_M5; Ls=_Ls;
    zolo_hi=_zolo_hi;
    zolo_lo=_zolo_lo;
    mobius_scale = 0.0;
    solver = HtCayleyZolo;
  }
  void WilsonCayleyZolo(double _mass, double _M5, int _Ls,double _zolo_lo,double _zolo_hi){
    mass=_mass; M5=_M5; Ls=_Ls;
    zolo_hi=_zolo_hi;
    zolo_lo=_zolo_lo;
    mobius_scale = 0.0;
    solver = HwCayleyZolo;
  }
  void WilsonCayleyTanh(double _mass, double _M5, int _Ls,double scale){
    mass=_mass; M5=_M5; Ls=_Ls;
    zolo_hi=0.0;
    zolo_lo=0.0;
    mobius_scale = scale;
    solver = HwCayleyTanh;
  }
  void WilsonContFracZolo(double _mass, double _M5, int _Ls,double _zolo_lo, double _zolo_hi){
    mass=_mass; M5=_M5; Ls=_Ls;
    zolo_hi=_zolo_hi;
    zolo_lo=_zolo_lo;
    mobius_scale = 0.0;
    solver = HwContFracZolo;
  }
  void pDWF(double _mass, double _M5,int _Ls){
    mass=_mass; M5=_M5; Ls=_Ls;
    zolo_hi=0;
    zolo_lo=1;
    mobius_scale = 0.0;
    solver = DWF;
  }
  void pDWFrb4d(double _mass, double _M5,int _Ls){
    mass=_mass; M5=_M5; Ls=_Ls;
    zolo_hi=0;
    zolo_lo=1;
    mobius_scale = 0.0;
    solver = DWFrb4d;
  }
  void WilsonPartFracZolo(double _mass, double _M5, int _Ls,double _zolo_lo, double _zolo_hi){
    mass=_mass; M5=_M5; Ls=_Ls;
    zolo_hi=_zolo_hi;
    zolo_lo=_zolo_lo;
    mobius_scale = 0.0;
    solver = HwPartFracZolo;
  }

 public:
  double mass;
  double M5;
  BfmSolver solver;
  double mobius_scale;
  double zolo_hi;
  double zolo_lo;
  int Ls;
};


#endif
