#include <unistd.h>
#include <stdio.h>
#include <chroma.h>
#include <bfm.h>
#include <bfm_qdp.h>


//
//
class britney : public bfm {
public:

  void randGauge(void)
  {
  for(int dir=0;dir<4;dir++){
  int x[4];
  int Ndircoco=36; /*4 directions stored only*/
  int Ncoco=9;

  for ( x[3]=0;x[3]<this->node_latt[3];x[3]++ ) { 
  for ( x[2]=0;x[2]<this->node_latt[2];x[2]++ ) { 
  for ( x[1]=0;x[1]<this->node_latt[1];x[1]++ ) { 
  for ( x[0]=0;x[0]<this->node_latt[0];x[0]++ ) { 
     
      for ( int coco=0;coco<9;coco++ ) { 
      for ( int reim=0;reim<2;reim++ ) { 

        double * bagel = this->u;
	int bbase = dir*9;
        int bidx = this->bagel_idx(x,reim,coco+bbase,Ndircoco,0);
        bagel[bidx] = drand48();

      }}

  }}}}
  }}
  void randFermion(Fermion_t x_t){

    double *x = (double *) x_t;
    int nspinco = 12;
    double *xx;
    double nrm = 0.0;

    for(int site=0;site<simd_cbvol;site++){
      for(int s=0;s<Ls;s++) {
     
	xx = &x[s*nspinco*nsimd*2   + site*nspinco*nsimd*2*Ls];

	for(int spinco=0;spinco<nspinco;spinco++){
	  for(int simd_el=0;simd_el<nsimd;simd_el++){
	    for(int reim=0;reim<2;reim++){
	      int idx = reim + simd_el*2 + spinco*nsimd*2;
	      xx[idx] = (drand48()-0.5)*2; //[-1,1] uniform
	    }}}
      }
    }  

  };
};


#define Printf printf

void benchmark(int lx,int ly, int lz, int lt, int Ls,int local);

int main (int argc,char **argv )
{
  Chroma::initialize(&argc,&argv);

  int lens[]  = { 16, 12, 8 , 6, 4 };
  int slens[] = { 16, 12, 8 , 4 };
  int nlen = 5;
  int nslen = 3;
  for(int local=0;local<2;local++){
  for(int ix=1;ix<nlen;ix++){
  for(int iy=1;iy<nlen;iy++){
  for(int iz=2;iz<nlen;iz++){
  for(int it=2;it<nlen;it++){
    for(int is=0;is<nslen;is++){

      int lx = lens[ix];
      int ly = lens[iy];
      int lz = lens[iz];
      int lt = lens[it];
      int Ls = slens[is];
      
      benchmark(lx,ly,lz,lt,Ls,local);
      
    }
  }}}}
  }

}

void benchmark(int lx,int ly, int lz, int lt, int Ls, int local)
{
  /********************************************************
   * Setup
   ********************************************************
   */
  
  double M5 = 1.8;
  double mass = 0.01;
  double mq = mass;

  /********************************************************
   * Setup DWF operator
   ********************************************************
   */
  bfmarg dwfa;
  britney  dwf;

  dwfa.node_latt[0]  = lx;
  dwfa.node_latt[1]  = ly;
  dwfa.node_latt[2]  = lz;
  dwfa.node_latt[3]  = lt;

  for(int mu=0;mu<4;mu++){
      dwfa.local_comm[mu] = local;
  }
  
  dwfa.solver = DWF;
  dwfa.precon_5d = 1;
  dwfa.Ls   = Ls;
  dwfa.M5   = M5;
  dwfa.mass = mq;
  dwfa.Csw  = 0.0;
  dwfa.max_iter = 1000;
  dwfa.residual = 1.e-8;
  Printf("Initialising bfm operator\n");
  dwf.init(dwfa);

  /********************************************************
   * Bagel internal single checkerboard vectors
   ********************************************************
   */
   Fermion_t psi_h[2];
   psi_h[0] = dwf.allocFermion();
   psi_h[1] = dwf.allocFermion();
   Fermion_t chi_h[2];
   chi_h[0] = dwf.allocFermion();
   chi_h[1] = dwf.allocFermion();

  dwf.randGauge();

  /*Import this checkerboard of source field to bagel*/
  Printf("Importing psi field cb %d\n",1);
  dwf.randFermion(psi_h[0]);
  dwf.randFermion(psi_h[1]);
 
  // Fill the other checkerboard of result with noise
  dwf.randFermion(chi_h[0]);
  dwf.randFermion(chi_h[1]);

  Printf("Local comm = %d\n",local);

  Printf("Benchmarking Dwilson for volume %d %d %d %d %d\n",lx,ly,lz,lt,Ls);
  double flops = 1344.0*lx*ly*lz*lt*Ls*0.5 * 100.0;
  uint64_t t1 = GetTimeBase();
  for(int i=0;i<100;i++) {
    dwf.dslash_generic(psi_h[0],chi_h[0],chi_h[0],0,0,0,0,0.0,1.0);
  }
  uint64_t t2 = GetTimeBase();
  Printf("%f Mflop/s\n",flops*1600./(t2-t1));
  Printf("Benchmarking CG");

#define NITER 1
  for(int i=0;i<NITER;i++) {
    dwf.axpy(chi_h[0],psi_h[0],psi_h[0],0.0)  ;
    dwf.axpy(chi_h[1],psi_h[0],psi_h[0],0.0)  ;
    dwf.CGNE(chi_h,psi_h);
  }

  Printf("Done\n"); 

}








